/**
 * @file
 * Helper for entity reference proc field.
 */
(function ($, Drupal, once) {
  'use strict';
  Drupal.behaviors.ProcBehavior = {
    attach: function (context, settings) {
      once('proc-decrypt', 'html', context)
        .forEach(function (element) {

          let procFieldElements = document.querySelectorAll('[proc="true"]');
          let procFields = [];

          procFieldElements.forEach((fieldElement, fieldElementIndex) => {
            procFields.push(fieldElement.attributes.name.value.substring( 0, fieldElement.attributes.name.value.indexOf( "[" ) ));
          });

          const submitId = drupalSettings.proc.submit_element_id;

          let submitElement = document.getElementById(submitId);

          procFields.map((fieldName, fieldIndex) => {
            let field = document.querySelector('[name^="' + fieldName + '"]');
            field.oninput = () => {
              if (submitElement.disabled === false && field.value != '') {
                // Disable submit when something is typed in for encryption:
                submitElement.disabled = true;
              }
              if (submitElement.disabled === true && field.value === '') {
                submitElement.disabled = false;
              }
            }

            let encryptCheckbox = document.querySelector('[id="encrypt-checkbox-' + fieldName + '"]');
            encryptCheckbox.oninput = () => {
              if (encryptCheckbox.value === '1' && submitElement.disabled === true) {
                // If for all other fields there is no plain text:
                let index = 0;
                procFields.map((fieldName, fieldIndex) => {
                  if (!document.querySelector('[name^="' + fieldName + '"]').value.startsWith('******* (')) {
                    console.log(document.querySelector('[name^="' + fieldName + '"]').value);
                    index++;
                  }
                });
                if (index === 1) {
                  submitElement.disabled = false;
                }
              }
              if (encryptCheckbox.value === '0' && submitElement.disabled === false) {
                submitElement.disabled = true;
              }
            }
          });
        });
    },
  };
})(jQuery, Drupal, once);
